<div>
	<form [formGroup]="registrationForm">
  
		<label>
			First Name*:
			<input id="firstName" class="form-control" formControlName="firstName" >
			
			<div *ngIf="registrationFormControl.firstName.invalid && (registrationFormControl.firstName.dirty || registrationFormControl.firstName.touched)" class="alert alert-danger">
			  	<div *ngIf="registrationFormControl.firstName.errors.required">
			    	First Name is required.
			  	</div>
			  	<div *ngIf="registrationFormControl.firstName.errors.minlength">
			   	 	First Name must be at least 4 characters long.
			  	</div>
			  	<div *ngIf="registrationFormControl.firstName.errors.maxlength">
			   	 	First Name can not be more than 15 characters long.
			  	</div>
			  	<div *ngIf="registrationFormControl.firstName.errors.pattern">
			   	 	First Name must be alphabet's only.
			  	</div>
			</div>
		</label>

		<label>
			Last Name*:
			<input class="form-control" id="lastName" formControlName="lastName">

			<div *ngIf="registrationFormControl.lastName.invalid && (registrationFormControl.lastName.dirty || registrationFormControl.lastName.touched)" class="alert alert-danger">
			  	<div *ngIf="registrationFormControl.lastName.errors.required">
			    	Last Name is required.
			  	</div>
			  	<div *ngIf="registrationFormControl.lastName.errors.minlength">
			   	 	Last Name must be at least 4 characters long.
			  	</div>
			  	<div *ngIf="registrationFormControl.lastName.errors.maxlength">
			   	 	Last Name can not be more than 15 characters long.
			  	</div>
			  	<div *ngIf="registrationFormControl.lastName.errors.pattern">
			   	 	Last Name must be alphabet's only.
			  	</div>
			</div>
		</label>

		<div formArrayName="addresses" ><!-- -->
			<div *ngFor="let row of registrationForm.get('addresses')['controls']; let i = index;" [formGroupName] = "i"><!-- *ngFor="let row of registrationForm.get('addresses').[controls];let i = index;" [formGroupName] = "i" -->

				<h3>Address</h3>
				<label>
					Street*:
					<input type="text" formControlName="street">
					<div *ngIf="row.get('street').invalid && (row.get('street').dirty || row.get('street').touched)" class="alert alert-danger">
					  	<div *ngIf="row.get('street').errors.required">
					    	Street is required.
					  	</div>
					  	<div *ngIf="row.get('street').errors.minlength">
				   	 		Street must be at least 4 characters long.
				  		</div>
				  		<div *ngIf="row.get('street').errors.maxlength">
					   	 	Street can not be more than 40 characters long.
					  	</div>
					    <div *ngIf="row.get('street').errors.pattern">
					   	 	Invalid street.
					  	</div>
				  	</div>
				</label>

				<label>
					City*:
					<input type="text" formControlName="city">

					<div *ngIf="row.get('city').invalid && (row.get('city').dirty || row.get('city').touched)" class="alert alert-danger">
					  	<div *ngIf="row.get('city').errors.required">
					    	City is required.
					  	</div>
					  	<div *ngIf="row.get('city').errors.minlength">
					   	 	City must be at least 4 characters long.
					  	</div>
					  	<div *ngIf="row.get('city').errors.maxlength">
					   	 	City can not be more than 20 characters long.
					  	</div>
					  	<div *ngIf="row.get('city').errors.pattern">
					   	 	City must be alphabet's only.
					  	</div>
				  	</div>
				</label>

				<label>
					State*:
					<input type="text" formControlName="state">

					<div *ngIf="row.get('state').invalid && (row.get('state').dirty || row.get('state').touched)" class="alert alert-danger">
					  	<div *ngIf="row.get('state').errors.required">
					    	State is required.
					  	</div>
					  	<div *ngIf="row.get('state').errors.minlength">
					   	 	State must be at least 4 characters long.
					  	</div>
					  	<div *ngIf="row.get('state').errors.maxlength">
					   	 	State can not be more than 20 characters long.
					  	</div>
					  	<div *ngIf="row.get('state').errors.pattern">
					   	 	State must be alphabet's only.
					  	</div>
				  	</div>
				</label>

				<label>
					ZIP Code*:
					<input type="text" formControlName="zip"><span>eg.111111</span>
					<div *ngIf="row.get('zip').invalid && (row.get('zip').dirty || row.get('zip').touched)" class="alert alert-danger">
					  	<div *ngIf="row.get('zip').errors.required">
					    	ZIP code is required.
					  	</div>
					  	<div *ngIf="row.get('zip').errors.minlength">
					   	 	ZIP must be at least 6 characters long.
					  	</div>
					  	<div *ngIf="row.get('zip').errors.maxlength">
					   	 	ZIP can not be more than 6 characters long.
					  	</div>
					  	<div *ngIf="row.get('zip').errors.pattern">
					   	 	Please match pattern.
					  	</div>
				  	</div>
				</label>

			</div>
		</div>

		<button (click)="addNewAddress()" [disabled]="!canAddAddress">Add Address</button>

		<button type="submit" [disabled]="!registrationForm.valid" (click)="onSubmit()">Submit</button>

	</form>
	<span *ngIf="isFormSubmitted">
		<p>First Name - {{registrationForm.value.firstName }}</p>
		<p>Last Name - {{registrationForm.value.lastName }}</p>
		<div *ngFor="let address of registrationForm.get('addresses')['value']; let i = index;">
			<h4>Address {{i+1}}</h4>	
			<p>Street - {{address.street }}</p>
			<p>City - {{address.city }}</p>
			<p>State - {{address.state }}</p>
			<p>ZIP Code - {{address.zip }}</p>
		</div>
		
	</span>
</div>